#ifndef CHARCOUNT_H
#define CHARCOUNT_H

/*
 * REFLEX - Real-time Event FLow EXecutive
 *
 * A lightweight operating system for deeply embedded systems.
 *
 *
 * Functions: charCount, charCountFinish
 * Revision: $Id:$
 * Author: Steffen Schulze
 *
 * Description: Helpfunctions for counting bytevalues
 *
 * (c) Steffen Schulze, BTU Cottbus 2005
 */


#include "../config.h"


/*
 * Counts a charactervalue and looks for sizelimit countvariables
 *
 * @param charToCount charactervalue to count
 * @param charCounter array with countvalues, index is charactervalue
 * @return count of charactervalue
 */
UINT16 charCount(BYTE charToCount, UINTMAX charCounter[256]);

/*
 * Stack the counterarray, so that all empty entries dont use memory.
 *
 * @param charCounter array with countvalues
 * @param charIndex output of translation charactervalue to new index
 * @return new count of all entries 
 */
UINT16 charCountFinish(UINTMAX charCounter[256], BYTE* charIndex);

#endif
