#include "compress/mtf/MtfCodec.h"


UINTMAX	MtfCodec::encode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize)
{
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tSTART encodeMTF(%d)\n",inputBufferSize);
	}
	#endif

	BYTE charList[256];
	for(UINT16 i = 0; i < 256; i++)
	{
		charList[i] = i;
	}
	
	for(UINTMAX inputBufferPos = 0; inputBufferPos < inputBufferSize; inputBufferPos++)
	{
		BYTE currChar = inputBuffer[inputBufferPos];
		
		UINT16 charListPos;
		for( charListPos = 0; (charListPos < 255) && (charList[charListPos] != currChar); charListPos++);
		
		outputBuffer[inputBufferPos] = charListPos;
		
		for( UINT16 i = charListPos; i > 0; i--)
		{
			charList[i] = charList[i - 1];
		}
		charList[0] = currChar;
		
		#ifdef TEXTDEBUG
		fprintf(stderr, "\t\t\t(%c:%d) -> (%d)\n",currChar ,currChar , charListPos);
		#endif

	}
	

	UINTMAX outputBufferPos = inputBufferSize;

	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tFINISH encodeMTF(%d)\n",outputBufferPos);
	}
	#endif
	
	return outputBufferPos;
}




UINTMAX MtfCodec::decode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize)
{
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tSTART decodeMTF(%d)\n",inputBufferSize);
	}
	#endif
	
	BYTE charList[256];
	for(UINT16 i = 0; i < 256; i++)
	{
		charList[i] = i;
	}
	
	for(UINTMAX inputBufferPos = 0; inputBufferPos < inputBufferSize; inputBufferPos++)
	{
		BYTE charListPos = inputBuffer[inputBufferPos];
		
		BYTE currChar = charList[charListPos];
		
		outputBuffer[inputBufferPos] = currChar;
		
		for( UINT16 i = charListPos; i > 0; i--)
		{
			charList[i] = charList[i - 1];
		}
		charList[0] = currChar;
		
		#ifdef TEXTDEBUG
		fprintf(stderr, "\t\t\t(%d) -> (%c)\n", charListPos ,currChar);
		#endif
	}
	
	UINTMAX outputBufferPos	= inputBufferSize;
	
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tFINISH decodeMTF(%d)\n",outputBufferPos);
	}
	#endif
	
	return outputBufferPos;
}


