#include "compress/rle/RleCodec.h"


UINTMAX	RleCodec::encode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize)
{
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tSTART encodeRLE(%d)\n",inputBufferSize);
	}
	#endif

	BYTE preChar;
	UINT16 count = 1;

	preChar = inputBuffer[0];
	UINTMAX outputBufferPos = 0;
	
	//fuer den ganzen inputPuffer
	for(UINTMAX inputBufferPos = 1; inputBufferPos <= inputBufferSize; inputBufferPos++)
	{
		BYTE currChar = 0;
		
		//kopiere inputPufferzeichen in Cachevariable
		if(inputBufferPos < inputBufferSize)
		{
			currChar = inputBuffer[inputBufferPos];
		}

		if
		(
			(preChar == currChar)				// aktueller Charakter gleich dem vorhergehenden Charakter
			&&									// AND
			(count < 255)						// groesse der Reihe noch nicht 255
			&&									// AND
			(inputBufferPos != inputBufferSize)	// aktuelle Postition noch nicht inputPufferende
		)
		{
			count++;				// erhoehe zeichencounter um 1
		}
		else
		{
			///////////////////////////////////
			// flush informations to outputbuffer
			if
			(
				(count > 3)
				||
				(
					(preChar == ESCAPECHAR)
					&&
					(count > 1)
				)
			)
			{
			
				#ifdef TEXTDEBUG
				fprintf(stderr, "rle(%d,%d) ",(count-1) ,preChar);
				#endif
				////////////////
				//output as rle
				outputBuffer[outputBufferPos] = ESCAPECHAR;
				outputBufferPos++;
				outputBuffer[outputBufferPos] = count - 1;
				outputBufferPos++;
				outputBuffer[outputBufferPos] = preChar;
				outputBufferPos++;
			}
			else
			{
				if( preChar == ESCAPECHAR)
				{
					#ifdef TEXTDEBUG
					fprintf(stderr, "esc() ");
					#endif
					////////////////
					//output esc
					outputBuffer[outputBufferPos] = ESCAPECHAR;
					outputBufferPos++;
					outputBuffer[outputBufferPos] = 0;
					outputBufferPos++;
				}
				else
				{
					////////////////
					//output pure
					for(BYTE i = 0; i < count; i++)
					{
						#ifdef TEXTDEBUG
						fprintf(stderr, "pure(%d) ",preChar);
						#endif
						outputBuffer[outputBufferPos] = preChar;
						outputBufferPos++;			
					}
				}
			}
			count = 1;						//deinit counter
			preChar = currChar;					//change preChar
		}	
    }

	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tFINISH encodeRLE(%d)\n",outputBufferPos);
	}
	#endif

	return outputBufferPos;
}




UINTMAX RleCodec::decode(BYTE* inputBuffer, UINTMAX inputBufferSize, BYTE* outputBuffer, UINTMAX outputBufferSize)
{
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tSTART decodeRLE(%d)\n",inputBufferSize);
	}
	#endif
	
	BYTE currChar;
	UINTMAX outputBufferPos = 0;
	for(UINTMAX inputBufferPos	= 0;inputBufferPos < inputBufferSize; inputBufferPos++)
	{
		currChar = inputBuffer[inputBufferPos];
		
		if(currChar == ESCAPECHAR)
		{
			inputBufferPos++;
			currChar = inputBuffer[inputBufferPos];
		
			if(currChar == 0)
			{
				#ifdef TEXTDEBUG
				fprintf(stderr, "esc() ");
				#endif
				outputBuffer[outputBufferPos] = ESCAPECHAR;
				outputBufferPos++;
			}
			else
			{
				UINT16 count = currChar + 1;
				inputBufferPos++;
				currChar = inputBuffer[inputBufferPos];
			
				#ifdef TEXTDEBUG
				fprintf(stderr, "rle(%d,%d) ",count-1,currChar);
				#endif
			
				for(UINT16 i = 0; i < count; i++)
				{
					outputBuffer[outputBufferPos] = currChar;
					outputBufferPos++;
				}
			
			}
			
		}
		else
		{
			#ifdef TEXTDEBUG
			fprintf(stderr, "pure(%d) ",currChar);
			#endif
			outputBuffer[outputBufferPos] = currChar;
			outputBufferPos++;
		}
		
		MEMORYCHECK((outputBufferPos + 10) > outputBufferSize)

	}
	
	#ifdef TEXTOUTPUT
	if( textOutputMode )
	{
		fprintf(stderr, "\t\tFINISH decodeRLE(%d)\n",outputBufferPos);
	}
	#endif
	
	return outputBufferPos;
}

